/** MIT License
* 
* Copyright (c) 2018 Ludovic CLUBER 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
* SOFTWARE.
*
* http://csvxjs.lcluber.com
*/

var CSVx=function(t){"use strict";function i(t,e){for(var n=0;n<e.length;n++){var r=e[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(t,r.key,r)}}var o=[{id:1,name:"info"},{id:2,name:"trace"},{id:3,name:"warn"},{id:4,name:"error"},{id:99,name:"off"}],s=function(){function t(t,e){this.setLevel(t),this.content=e}var e=t.prototype;return e.setLevel=function(t){this.level=this.findLevel(t)},e.getLevelId=function(){return this.level.id},e.display=function(){},e.findLevel=function(t){for(var e=0;e<o.length;e++){var n=o[e];if(n.name===t)return n}return this.level?this.level:o[0]},t}(),f=function(){function r(){}var t,e,n;return r.info=function(t){r.log("info",t)},r.trace=function(t){r.log("trace",t)},r.time=function(t){r.log("time",t)},r.warn=function(t){r.log("warn",t)},r.error=function(t){r.log("error",t)},r.log=function(t,e){r.addMessage(t,e);var n=this.messages[this.nbMessages-1];this._level.id<=n.getLevelId()&&n.display()},r.addMessage=function(t,e){this.messages.push(new s(t,e)),this.nbMessages++},r.findLevel=function(t){for(var e=0;e<o.length;e++){var n=o[e];if(n.name===t)return n}return this._level?this._level:o[0]},t=r,(e=[{key:"level",set:function(t){r._level=r.findLevel(t)},get:function(){return r._level.name}}])&&i(t.prototype,e),n&&i(t,n),r}();f._level=f.findLevel(o[0].name),f.messages=[],f.nbMessages=0,f.target=document.getElementById("Mouette");var c=function(){function t(){}return t.json=function(t){if(!this.string(t))return!1;var e=t.replace(/(\r\n|\n|\r|\t)/gm,"");try{e=JSON.parse(t)}catch(t){return f.error(t),!1}return e},t.function=function(t){return t&&"[object Function]"==={}.toString.call(t)},t.object=function(t){return null!==t&&"object"==typeof t},t.ascii=function(t,e){return(e?/^[\x00-\xFF]*$/:/^[\x00-\x7F]*$/).test(t)},t.integer=function(t){return t===parseInt(t,10)},t.string=function(t){return"string"==typeof t},t}(),a=function(){function t(){}return t.scrollToBottom=function(t){t.scrollTop=t.scrollHeight},t.findById=function(t){return document.getElementById(t)},t.showById=function(t){this.findById(t).style.display="block"},t.hideById=function(t){this.findById(t).style.display="none"},t.showOverflow=function(){document.body.style.overflow="visible"},t.hideOverflow=function(){document.body.style.overflow="hidden"},t.getInputValue=function(t){return this.findById(t).value},t.clearInputValue=function(t){this.findById(t).value=""},t.focusOn=function(t){this.findById(t).focus()},t.addHTMLElement=function(t,e,n){var r=document.createElement(e);return void 0!==n&&Object.keys(n).forEach(function(t){"textContent"===t||"innerHTML"===t?r[t]=n[t]:r.setAttribute(t,n[t])}),t.appendChild(r),r},t}(),e=function(){function t(){}return t.data=function(t,e,n){if(!c.object(e[0])&&!c.json(e[0]))return!1;n&&this.setOptions(n);var r="data:"+this.options.data+";charset="+this.options.charset+",";return this.options.labels&&(r+=this.createLabels(e),f.info("[CSVx] "+t+" labels ready")),r+=this.createTable(e),f.info("[CSVx] "+t+" table ready"),this.download(r,t),!0},t.setOptions=function(t){for(var e in t)t.hasOwnProperty(e)&&this.options.hasOwnProperty(e)&&(this.options[e]=t[e])},t.download=function(t,e){var n=encodeURI(t),r=a.addHTMLElement(document.body,"a",{href:n,download:e+".csv"});r.click(),document.body.removeChild(r),f.info("[CSVx] "+e+" downloading")},t.createTable=function(t){var e="",n=t,r=Array.isArray(n),i=0;for(n=r?n:n[Symbol.iterator]();;){var o;if(r){if(i>=n.length)break;o=n[i++]}else{if((i=n.next()).done)break;o=i.value}var s=o,a=c.json(s)||s;if(!c.object(a))return e;var u="";for(var l in a)a.hasOwnProperty(l)&&(u+=this.createField(a[l]));e+=this.createRow(u)}return e},t.createLabels=function(t){var e=c.json(t[0])||t[0],n="";for(var r in e)e.hasOwnProperty(r)&&(n+=this.createField(r));return this.createRow(n)},t.createRow=function(t){return t+this.options.CRLF},t.createField=function(t){return this.options.quote+t+this.options.quote+this.options.separator},t}();e.options={data:"text/csv",charset:"utf-8",labels:!0,quote:'"',separator:",",CRLF:"\r\n"};var n=function(){function t(){}return t.setOptions=function(t){this.setObject("options",t)},t.setCSS=function(t){this.setObject("css",t)},t.array=function(t,e,n){e&&this.setOptions(e),n&&this.setCSS(n);var r=t.split(this.options.CRLF);if(!r.length)return f.warn("[CSVx] "+this.options.CRLF+" CRLF not found"),!1;var i=[],o=r,s=Array.isArray(o),a=0;for(o=s?o:o[Symbol.iterator]();;){var u;if(s){if(a>=o.length)break;u=o[a++]}else{if((a=o.next()).done)break;u=a.value}var l=u.split(this.options.separator);if(this.options.quote)for(var c=0;c<l.length;c++)l[c]=l[c].slice(1,-1);i.push(l)}return i},t.table=function(t,e,n){var r=this.array(t,e,n);if(r){for(var i="",o=[],s=0;s<r.length;s++){var a="td",u="";!s&&this.options.labels?(a="th",this.css.th&&(u=' class = "'+this.css.th+'"'),i="<thead>"+this.createTr(r[s],a,u)+"</thead>"):o.push(this.createTr(r[s],a,""))}if(i||o.length)return"<table "+(this.css.table?'class="'+this.css.table+'"':"")+">"+i+"<tbody>"+o.join("")+"</tbody></table>"}return!1},t.createTr=function(t,e,n){return"<tr><"+e+n+">"+t.join("</"+e+"><"+e+n+">")+"</"+e+"></tr>"},t.setObject=function(t,e){for(var n in e)e.hasOwnProperty(n)&&this[t].hasOwnProperty(n)&&(this[t][n]=e[n])},t}();return n.options={labels:!0,quote:'"',separator:",",CRLF:"\r\n"},n.css={table:"",th:""},t.Export=e,t.Convert=n,t}({});